<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
<meta http-equiv="content-type" content="text/html; charset=utf-8">
<title>zh-tw/HowTos/SoftwareRAIDonCentOS5</title>
<link rel="stylesheet" type="text/css" media="all" charset="utf-8" href="modern/css/common.css">
<link rel="stylesheet" type="text/css" media="screen" charset="utf-8" href="modern/css/screen.css">
<link rel="stylesheet" type="text/css" media="print" charset="utf-8" href="modern/css/print.css">
<style type="text/css">
ul.pagetitle{
  display: inline;
  margin: 0;
  padding: 0;
  font-size: 1.5em;
}
li.pagetitle{
  display: inline;
  margin: 0;
}
td.noborder {
  border: 0;
}
</style>
</head>
<body>
<table>
<tr>
<td class="noborder">
<img src="logo.png">
</td>
<td class="noborder">
<ul class="pagetitle">
<li class="pagetitle"><a class="backlink">zh-tw/HowTos/SoftwareRAIDonCentOS5</a>
</ul>
<br><br>
[<a href="FrontPage.html">FrontPage</a>]&nbsp;[<a href="TitleIndex.html">TitleIndex</a>]&nbsp;[<a href="WordIndex.html">WordIndex</a>]&nbsp;
</td>
</tr>
</table>
<hr>
<div id="page"><h1 style="background-color:Red; color:White">This is a read-only <a href="https://gitlab.com/CentOS/docs/wiki_archives">archived version</a> of wiki.centos.org</h1>
<div dir="ltr" id="content" lang="zh-tw"><span class="anchor" id="top"></span>
<span class="anchor" id="line-1"></span><span class="anchor" id="line-2"></span><span class="anchor" id="line-3"></span><p class="line867">
<h1 id="A.2BWYJPVVco_CentOS_5_.2BTgqKLX9uTgBQC47fTvZ4bHbklmNSFw-">如何在 CentOS 5 上設置一個軟件硬盤陣列</h1>
<span class="anchor" id="line-4"></span><p class="line862">這篇文章探討一個方法，可於安裝時在沒有真實硬盤陣列控制器的系統上建立一個軟件（mdraid）RAID1。此方法<strong>沒有</strong> CentOS 計劃的支援，也<strong>不是</strong>一個適合普通用戶的做法（請參閱下文的「計設考慮因素」備註）。此篇文章的作用是記錄一個實驗性質的做法，它的脆弱成果在內核更新後便無法更新。我們<strong>並不</strong>推薦它。多年的經驗告訴我們，你很可能<strong>會</strong>忘記更新開機程式，因此損失數據的機會比硬碟失效的可能性更高。 <span class="anchor" id="line-5"></span><span class="anchor" id="line-6"></span><p class="line862">「不獲支援」的意思就是：當你在 #centos IRC 頻道上查詢有關此篇文章時，頻道上的常客將會告訴你它<strong>不獲支援</strong>，及<strong>不要這樣做</strong> <span class="anchor" id="line-7"></span><span class="anchor" id="line-8"></span><p class="line867"><img alt="/!\" height="16" src="/moin_static1911/modern/img/alert.png" title="/!\" width="16" /> 設計考慮因素：在 /boot 分割區採用 RAID 是否明智？位於掛載點：<strong>/boot/</strong> 的內容普遍是於置於在一個<strong>原生</strong>（非 RAID）的分割區內。它的大小相對較細，傳統是 250 MB 之下。因此在安裝或更新<strong>後</strong>，你可以簡易地利用這樣一個小腳本把內容複製到由 RAID 提供冗餘的位置：{{{ # [ ! -d /root/boot_backup ] &amp;&amp; mkdir -p /root/boot_backup <span class="anchor" id="line-9"></span># rsync -a -v /boot/. /root/boot_backup/. }}} <span class="anchor" id="line-10"></span>這樣你便能透過 RAID 保護該分割區的副本。當然 RAID 並非備份的方案。採用此方法可避免下文介紹的<strong>雜牌</strong>及脆弱做法。 <span class="anchor" id="line-11"></span><span class="anchor" id="line-12"></span><div><table><tbody><tr>  <td style="background-color: #ff1480"><p class="line862"> <img alt="&lt;!&gt;" height="16" src="/moin_static1911/modern/img/attention.png" title="&lt;!&gt;" width="16" /> 這篇文章所描述的行動可以損毀現有的檔案系統。請先在一個測試裝置上進行實驗，並建立最新及可靠的備份，然後才正式執行。請勿盲目地剪貼指令，尤其是以 <em>root</em> 身份來執行，除非你清楚瞭解它們的效用。 </td>
</tr>
</tbody></table></div><span class="anchor" id="line-13"></span><span class="anchor" id="line-14"></span><p class="line874">這個做法意味著控制器會將原始塊裝置直接暴露給操作系統。它亦假設所涉及的裝置是頭兩個 SATA 或 SCSI 硬盤，/dev/sda 及 /dev/sdb。若果是頭兩個平衡 ATA 硬盤，請將 /dev/sda 及 /dev/sdb 改為 /dev/hda 及 /dev/hdb（或者 /dev/sdc，如果是第二個主硬盤）。假如是其它裝置，請適切地調整硬盤稱謂。請按你的處境小心修改指令，切勿盲目地遵從下面的步驟。 <span class="anchor" id="line-15"></span><span class="anchor" id="line-16"></span><p class="line874">要正確開機，/boot 必須位於非硬盤陣列或 RAID1 分割區。RAID0、RAID5 及其它 RAID 類型不適用於 /boot，而 RAID0（沒有冗餘的條紋）則不建議給重要的分割區使用。只要滿足了 /boot 的限制，主目錄及其它分割區便可以採用 RAID5 或其它類型；然而，這個範例不會涵蓋那些選擇。 <span class="anchor" id="line-17"></span><span class="anchor" id="line-18"></span><p class="line867"><strong>dd 這個指令及下面所描述的步驟將會毀滅硬盤上的所有資料。如果硬盤上藏有需用的資料，請將它們備份。</strong> <span class="anchor" id="line-19"></span><span class="anchor" id="line-20"></span><p class="line867">
<h2 id="A.2BeyxOAJDoTv0-">1. 第一部份</h2>
<span class="anchor" id="line-21"></span><ol type="1"><li>停用主機板或 RAID 控制器 BIOS 上的任何模擬的硬盤陣列，令它成為一個正常的控制器 —— 多數是 ATA 或 SATA，也有可能是 SCSI。假如之前採用的是模擬硬盤陣列，你或許須要蓋過分割區列表。切勿載入 RAID 驅動程式。以下指令可以於圖像安裝分割硬盤前在第二個虛擬控制台（Ctrl-Alt-F2）內執行；或者在安裝媒體的修復模式中執行；又或者透過 LiveCD 來執行。裝置內的分區表將會被清除，而硬盤上的所有資料將會被遺失！ <span class="anchor" id="line-22"></span><ul><li style="list-style-type:none">{{{dd if=/dev/zero of=/dev/sda bs=512 count=64 <span class="anchor" id="line-23"></span></li></ul></li></ol><p class="line874">dd if=/dev/zero of=/dev/sdb bs=512 count=64}}} <span class="anchor" id="line-24"></span><ol type="1"><li>開始以圖像介面安裝 CentOS。你可能需要用 "boot: linux nodmraid" 或在首個安裝選單按 [Tab] 來加入 nodmraid 這個開機指令。 <span class="anchor" id="line-25"></span></li><li>自訂分割區並移除所有分割區，包括 LVM，來作個新開始 <span class="anchor" id="line-26"></span></li><li>在 sda 及 sdb 上為 /boot 建立一個 ~100MB 的軟件硬盤陣列分割區 <span class="anchor" id="line-27"></span></li><li>在 sda 及 sdb 上為 swap 建立一個軟件硬盤陣列分割區。這個分割區的大小視乎記憶體數量及個人喜好。這個範件採用 1GB。這將會是個硬盤陣列式的 swap*** <span class="anchor" id="line-28"></span></li><li>在 sda 及 sdb 上為 / 建立一個軟件硬盤陣列分割區並用盡所有空間 <span class="anchor" id="line-29"></span></li><li>點擊 RAID 鍵來建立一個硬盤陣列裝置 <span class="anchor" id="line-30"></span></li><li>選取那兩個 100MB 的分割區，設定掛載點為 /boot，檔案系統類型為 ext3，硬盤陣列類型為 RAID1（預設裝置名稱是 md0），點擊 OK <span class="anchor" id="line-31"></span></li><li>點擊 RAID 鍵來建立一個硬盤陣列裝置 <span class="anchor" id="line-32"></span></li><li>選取那兩個 1GB 的分割區，設定檔案系統類型為 swap，硬盤陣列類型為 RAID1（預設裝置名稱是 md1），點擊 OK <span class="anchor" id="line-33"></span></li><li>點擊 RAID 鍵來建立一個硬盤陣列裝置 <span class="anchor" id="line-34"></span></li><li>選取那兩個大的分割區，設定掛載點為 /，設定檔案系統類型為 ext3，硬盤陣列類型為 RAID1（預設裝置名稱是 md2），點擊 OK <span class="anchor" id="line-35"></span></li><li>你的分割區已經建立好。你的畫面應該看似以下樣子： <span class="anchor" id="line-36"></span><ul><li style="list-style-type:none"><p class="line891"><strong>RAID 裝置</strong> <span class="anchor" id="line-37"></span><span class="anchor" id="line-38"></span><span class="anchor" id="line-39"></span><span class="anchor" id="line-40"></span><pre><span class="anchor" id="line-1"></span>/dev/md0 ext3 [選取了] 100
<span class="anchor" id="line-2"></span>/dev/md1 swap [選取了] 1024
<span class="anchor" id="line-3"></span>/dev/md2 ext3 [選取了] [很多 GB]</pre><span class="anchor" id="line-41"></span><p class="line891"><strong>硬磁</strong> <span class="anchor" id="line-42"></span><span class="anchor" id="line-43"></span><span class="anchor" id="line-44"></span><span class="anchor" id="line-45"></span><span class="anchor" id="line-46"></span><span class="anchor" id="line-47"></span><span class="anchor" id="line-48"></span><span class="anchor" id="line-49"></span><span class="anchor" id="line-50"></span><pre><span class="anchor" id="line-1-1"></span>/dev/sda
<span class="anchor" id="line-2-1"></span>   /dev/sda1 /dev/md0 software RAID [未被選取] 100
<span class="anchor" id="line-3-1"></span>   /dev/sda2 /dev/md1 software RAID [未被選取] 1024
<span class="anchor" id="line-4"></span>   /dev/sda3 /dev/md2 software RAID [未被選取] [很多 GB]
<span class="anchor" id="line-5"></span>/dev/sdb
<span class="anchor" id="line-6"></span>   /dev/sdb1 /dev/md0 software RAID [未被選取] 100
<span class="anchor" id="line-7"></span>   /dev/sdb2 /dev/md1 software RAID [未被選取] 1024
<span class="anchor" id="line-8"></span>   /dev/sdb3 /dev/md2 software RAID [未被選取] [很多 GB]</pre><span class="anchor" id="line-51"></span><span class="anchor" id="line-52"></span></li></ul></li><li class="gap">點擊 Next 進到 GRUB 啟動程式畫面 <span class="anchor" id="line-53"></span></li><li>預設 GRUB 會安裝到 /dev/sda，點擊 Next <span class="anchor" id="line-54"></span></li><li>繼續安裝 CentOS，選取所需的套件 <span class="anchor" id="line-55"></span></li><li>當 CentOS 已完成安裝並重新啟動，請進到第二部份。切勿更新 CentOS；切勿做其它事情！ <span class="anchor" id="line-56"></span></li></ol><p class="line867">
<h2 id="A.2BeyxOjJDoTv0-">2. 第二部份</h2>
<span class="anchor" id="line-57"></span><p class="line874">這部份會確保 RAID1 /boot 的兩個成員都可以用來開機。請在硬盤失效／更替後重複這個部份。 <span class="anchor" id="line-58"></span><span class="anchor" id="line-59"></span><p class="line867">
<h3 id="A.2BZbls1U4A_.2BIBQgFA_.2BlYtqX2ZCdSg_GRUB">2.1. 方法一 —— 開機時用 GRUB</h3>
<span class="anchor" id="line-60"></span><p class="line874">在 GRUB 選單輸入 "c" 選項進到 GRUB 的提示行，接著： <span class="anchor" id="line-61"></span><span class="anchor" id="line-62"></span><ul><li style="list-style-type:none"><span class="anchor" id="line-63"></span><span class="anchor" id="line-64"></span><span class="anchor" id="line-65"></span><span class="anchor" id="line-66"></span><pre><span class="anchor" id="line-1-2"></span>grub&gt; root (hd1,0)
<span class="anchor" id="line-2-2"></span>grub&gt; setup (hd1)
<span class="anchor" id="line-3-2"></span>grub&gt; root (hd0,0)
<span class="anchor" id="line-4-1"></span>grub&gt; setup (hd0)</pre><span class="anchor" id="line-67"></span></li></ul><p class="line874">按 ESC 鍵返回 GRUB 選單，然後正常開機。進行方法二裡面的 1 及 5-8 步。 <span class="anchor" id="line-68"></span><span class="anchor" id="line-69"></span><p class="line867">
<h3 id="A.2BZbls1U6M_.2BIBQgFA_.2BVyiQS09cTi12hHz7fXF1KA_GRUB">2.2. 方法二 —— 在運作中的系統用 GRUB</h3>
<span class="anchor" id="line-70"></span><ol type="1"><li><p class="line862">確定你是 <a href="./zh(2f)TipsAndTricks(2f)BecomingRoot.html">root</a>。 <span class="anchor" id="line-71"></span></li><li>輸入 "/sbin/grub" 這個指令，按 Enter <span class="anchor" id="line-72"></span></li><li>在 GRUB 的指令殼輸入以下指令： <span class="anchor" id="line-73"></span><ul><li style="list-style-type:none"><span class="anchor" id="line-74"></span><span class="anchor" id="line-75"></span><span class="anchor" id="line-76"></span><span class="anchor" id="line-77"></span><span class="anchor" id="line-78"></span><span class="anchor" id="line-79"></span><span class="anchor" id="line-80"></span><pre><span class="anchor" id="line-1-3"></span>grub&gt; device (hd0) /dev/sdb
<span class="anchor" id="line-2-3"></span>grub&gt; device (hd1) /dev/sda
<span class="anchor" id="line-3-3"></span>grub&gt; root (hd0,0)
<span class="anchor" id="line-4-2"></span>grub&gt; setup (hd0)
<span class="anchor" id="line-5-1"></span>grub&gt; root (hd1,0)
<span class="anchor" id="line-6-1"></span>grub&gt; setup (hd1)
<span class="anchor" id="line-7-1"></span>grub&gt; quit</pre><span class="anchor" id="line-81"></span></li></ul></li><li>祝你好運。輸入 "reboot"，按 Enter。 <span class="anchor" id="line-82"></span></li><li>當開機完成後，進行系統更新。 <span class="anchor" id="line-83"></span></li><li>如果內核或 glibc 更新了，請重新開機。 <span class="anchor" id="line-84"></span></li><li>如果有新的內核，輸入 "uname -a" 後按 Enter 來檢查你的確在運用最新的內核。 <span class="anchor" id="line-85"></span></li><li>完成了！ <span class="anchor" id="line-86"></span></li></ol><p class="line867"><hr /><p class="line874"> <span class="anchor" id="line-87"></span><ul><li style="list-style-type:none"><p class="line862">這份指引是根據 <a class="http" href="http://www.centos.org/modules/newbb/viewtopic.php?viewmode=flat&amp;topic_id=19853&amp;forum=37">CentOS 論壇議題</a>引述 <a href="./TimVerhoeven.html">TimVerhoeven</a> 在 irc.freenode.net 上的 #centos 頻道所提供的資料，吸納了論壇用戶及 <a class="http" href="http://lists.centos.org/mailman/listinfo/centos-docs">centos-docs</a> 上的回饋作出多番修飾而寫成的。 <span class="anchor" id="line-88"></span><span class="anchor" id="line-89"></span></li><li class="gap" style="list-style-type:none">以上程序假設一個圖像化的安裝。在文字模式下建立 RAID-1 裝置是可行的，但頗為冗長及苛刻。你首先要在硬盤上建立每個 RAID 成員分割區，並且指定採用單一個硬盤。如果你不為分割區個指定單一的硬盤（例如 sda 或 sdb），Disk Druid 似乎會在建立 RAID 裝置時修改你的配置。在建立 RAID 裝置的過程中，請確定你在每個硬盤上單單選取所需的 RAID 分割區。 <span class="anchor" id="line-90"></span><span class="anchor" id="line-91"></span></li><li class="gap" style="list-style-type:none"><p class="line862">同一個方法應該可以應用在位於 RAID1 上的 /，而不須 /boot。這個 <a class="http" href="http://www.texsoft.it/index.php?c=hardware&amp;m=hw.storage.grubraid1&amp;l=it">Fedora 指南</a>的連結就採用了這個方法，它應該頗合用。這篇 Fedora 文章亦為了如何用 mdadm 進行修復提供了很好的指引。 <span class="anchor" id="line-92"></span></li><li style="list-style-type:none"><p class="line862">本 Wiki 內其它有關 RAID 的文章包括 <a href="./zh(2f)HowTos(2f)CentOS5ConvertToRAID.html">如何利用修復光碟將一個 CentOS 5 系統轉換成 RAID1</a> 及 <a href="./zh(2f)HowTos(2f)Install_On_Partitionable_RAID1.html">如何在一個可分割的軟件 RAID1 上安裝 CentOS 5</a>。 <span class="anchor" id="line-93"></span></li><li style="list-style-type:none">一般有關軟件硬盤陣列的文章： <span class="anchor" id="line-94"></span><ul><li style="list-style-type:none"><p class="line891"><a class="http" href="http://tldp.org/HOWTO/Software-RAID-HOWTO.html">http://tldp.org/HOWTO/Software-RAID-HOWTO.html</a> <span class="anchor" id="line-95"></span><a class="http" href="http://en.wikipedia.org/wiki/Mdadm">http://en.wikipedia.org/wiki/Mdadm</a> <span class="anchor" id="line-96"></span></li></ul></li><li style="list-style-type:none"><p class="line862">一篇不錯的 Linux Journal 文章關於 <a class="http" href="http://www.linuxjournal.com/article/8874">修復 RAID 及 LVM2 磁區</a>。 <span class="anchor" id="line-97"></span><span class="anchor" id="line-98"></span></li><li class="gap"><p class="line862">* 有些控制器聲稱是硬件硬盤陣列，但仿似 winmodem 般須要用驅動程式來運作。這些控制器就是所謂的「模擬 RAID」或「冒牌貨」，它們在 CentOS 上停用 RAID 功能會更佳。這篇<a class="http" href="http://www.brandonchecketts.com/archives/disabling-dmraid-fakeraid-on-centos-5">外置文章</a>頗詳細地探討這些議題。 <span class="anchor" id="line-99"></span><span class="anchor" id="line-100"></span></li><li class="gap"><p class="line862">** 欲得到有關硬盤列件的解釋，請閱讀 <a class="http" href="http://en.wikipedia.org/wiki/Redundant_array_of_independent_disks">Wikipedia 文章</a>，或在 google 上搜尋其它精彩描述。要得更多針對企業級 Linux 5 的資訊，請參閱部署指南的<a class="http" href="http://www.centos.org/docs/5/html/5.2/Deployment_Guide/ch-raid.html">「冗餘硬盤陣列（RAID）」</a>部份或 CentOS 5 常見問題集內的<a class="http" href="http://wiki.centos.org/zh/FAQ/CentOS5#head-d9e6f2383c8c976a90228b4e680814f86e218e4e">「我如何在 CentOS 5 上安裝一個軟件硬盤陣列？」</a>。 <span class="anchor" id="line-101"></span><span class="anchor" id="line-102"></span></li><li class="gap">*** 另一個捨棄冗餘來換取更佳效能和雙倍調換空間，但沿用相同分割區大小的做法，就是採用兩個非硬盤陣列的分割區。這樣做的效能與 RAID0 相若，但就算一個硬盤壞了仍能捱得住，雖然只會剩下一半的調換空間。 <span class="anchor" id="line-103"></span><span class="anchor" id="line-104"></span></li><li class="gap">選擇二：把剩餘的空間放在另一個 RAID1，然後在 /dev/md1 上建立一個 LVM 磁區，把 /、swap、甚至 /home 或其它檔案系統以邏輯磁區的型式建立在 LVM 內。請跳過第 1 分段餘下的指引。 <span class="anchor" id="line-105"></span><span class="anchor" id="line-106"></span></li></ul><p class="line867"><hr /><p class="line874"> <span class="anchor" id="line-107"></span>這頁的英文版由 <a href="./PhilSchaffner.html">PhilSchaffner</a> 建立及維護。歡迎其他擁有編輯權限的 Wiki 貢獻者作出更正或添加。其他有意見的讀者可以在我的 Wiki 頁內找到聯絡資料。 <span class="anchor" id="line-108"></span><span class="anchor" id="line-109"></span><p class="line867"><small>Translation of revision 37</small> <span class="anchor" id="line-110"></span><span class="anchor" id="bottom"></span></div>
</div>
<hr>
2023-09-11 07:23
</body>
</html>
